#include <gtk/gtk.h>

#include "blinken_xmms.h"

static GtkWidget *configure_win = NULL;
static GtkWidget *vbox, *options_frame, *options_vbox;
static GtkWidget *bbox, *ok, *cancel;

static GtkWidget *dev_ip, *dev_port;

static void configure_ok(GtkWidget *w, gpointer data)
{
	blinken_cfg.ip = g_strdup(gtk_entry_get_text(GTK_ENTRY(dev_ip)));
	blinken_cfg.port = atoi(gtk_entry_get_text(GTK_ENTRY(dev_port)));
	printf("ip: %s\nport: %d\n",blinken_cfg.ip,blinken_cfg.port);
	blinken_cleanup();
	blinken_udp_init();
	blinken_save_config();
	gtk_widget_destroy(configure_win);
}

void blinken_configure (void)
{
	GtkWidget *frame, *table, *label, *label_port;
	if(configure_win)
		return;

	blinken_read_config();

	configure_win = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_container_set_border_width(GTK_CONTAINER(configure_win), 10);
	gtk_window_set_title(GTK_WINDOW(configure_win), ("Blinken XMMS configuration"));
	gtk_window_set_policy(GTK_WINDOW(configure_win), FALSE, FALSE, FALSE);
	gtk_window_set_position(GTK_WINDOW(configure_win), GTK_WIN_POS_MOUSE);
	gtk_signal_connect(GTK_OBJECT(configure_win), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroyed),
			   &configure_win);

	vbox = gtk_vbox_new(FALSE, 5);

	options_frame = gtk_frame_new(("Options:"));
	gtk_container_set_border_width(GTK_CONTAINER(options_frame), 5);

	options_vbox = gtk_vbox_new(FALSE, 5);
	gtk_container_set_border_width(GTK_CONTAINER(options_vbox), 5);

	frame = gtk_frame_new(("Connection"));
	gtk_box_pack_start(GTK_BOX(options_vbox), frame, FALSE, FALSE, 0);

	table = gtk_table_new(2, 1, FALSE);
	gtk_container_set_border_width(GTK_CONTAINER(table), 5);
	gtk_container_add(GTK_CONTAINER(frame), table);
	gtk_table_set_row_spacings(GTK_TABLE(table), 5);
	gtk_table_set_col_spacings(GTK_TABLE(table), 5);

	label = gtk_label_new(("IP Adr.:"));
	gtk_misc_set_alignment(GTK_MISC(label), 1.0, 0.5);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 1, 0, 1);
	gtk_widget_show(label);

	dev_ip = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(dev_ip), blinken_cfg.ip);
	gtk_table_attach_defaults(GTK_TABLE(table), dev_ip, 1, 2, 0, 1);
	gtk_widget_show(dev_ip);

	label_port = gtk_label_new(("Port:"));
	gtk_misc_set_alignment(GTK_MISC(label_port), 1.0, 0.5);
	gtk_table_attach_defaults(GTK_TABLE(table), label_port, 0, 1, 1, 2);
	gtk_widget_show(label_port);

	dev_port = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(dev_port), g_strdup_printf("%d", blinken_cfg.port));
	gtk_table_attach_defaults(GTK_TABLE(table), dev_port, 1, 2, 1, 2);
	gtk_widget_show(dev_port);

	gtk_widget_show(table);
	gtk_widget_show(frame);

	gtk_container_add(GTK_CONTAINER(options_frame), options_vbox);
	gtk_widget_show(options_vbox);

 	gtk_box_pack_start(GTK_BOX(vbox), options_frame, TRUE, TRUE, 0);
	gtk_widget_show(options_frame);

	bbox = gtk_hbutton_box_new();
	gtk_button_box_set_layout(GTK_BUTTON_BOX(bbox), GTK_BUTTONBOX_END);
	gtk_button_box_set_spacing(GTK_BUTTON_BOX(bbox), 5);
	gtk_box_pack_start(GTK_BOX(vbox), bbox, FALSE, FALSE, 0);

	ok = gtk_button_new_with_label(("OK"));
	gtk_signal_connect(GTK_OBJECT(ok), "clicked", GTK_SIGNAL_FUNC(configure_ok), NULL);
	GTK_WIDGET_SET_FLAGS(ok, GTK_CAN_DEFAULT);
	gtk_box_pack_start(GTK_BOX(bbox), ok, TRUE, TRUE, 0);
	gtk_widget_show(ok);
	

	cancel = gtk_button_new_with_label(("Cancel"));
	gtk_signal_connect_object(GTK_OBJECT(cancel), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
				  GTK_OBJECT(configure_win));
	GTK_WIDGET_SET_FLAGS(cancel, GTK_CAN_DEFAULT);
	gtk_box_pack_start(GTK_BOX(bbox), cancel, TRUE, TRUE, 0);
	gtk_widget_show(cancel);
	gtk_widget_show(bbox);
	
	gtk_container_add(GTK_CONTAINER(configure_win), vbox);
	gtk_widget_show(vbox);
	gtk_widget_show(configure_win);
	gtk_widget_grab_default(ok);
}
